(function($)
{
    var PlayerPlugin 			        = null;
    var AudioPlugin 			        = null;
    var TVMWPlugin 				= null;
    var TVPlugin                        = null;
    var PluginAPI                       = null;
    var objVideo2_controller 	= null;
    var lastMediaCallback        = null;
    var errorCallback                = null;
    var statsController 	            = null;
    var rightsController 	        = null;
    var movieSeenController     = null;
    
    var self;
    
    var media = new Array();
    var currentMediaIndex = 0;
    
    //constant for size of screen
    var MAX_HEIGHT_SCREEN = 540;
    var MAX_WIDTH_SCREEN 	= 960;
    var JUMP_SECONDS 		    = 10;
    var jumpSecondsEvents      = 0;
    var jumpSecondsRun           = 0;
    var jumpOffset                    = 0;
    var jumpSecondsTimer;
    var jumpType;
    
    //constants for status of media    
    var PLAYING     	= 1;
    var PAUSED  	    = 2;
    var STOPPED 	    = 3;
    var RESUME 		= 4;
    
    //initial value for status
    var status = STOPPED;
    var statusBeforeJump = null;
    
    // total time of video
    this.totalTime = 0;
    this.currentTime = 0;
    
    var timeSecondHidden	= 5000;                                // variable used to be hidden the progress bar after request to change for full screen
    var timeFullScreen 		    = 0;                                      // variable to get the value of time when the full screen is requested
    var boolMarkTime 		    = true;                                 // variable indicating if the time was marking when Full Screen called
    var boolBeginVideo 		= false;                               // variable used to prohibit to press key pause, play, stop, forward, backward before the Video begins
    
    var volumeSupported         = true;
    var volumeOSDSupported  = true;
    
    var scrollingButtonInterval = null;
    
	 $.fn.sfVideo2 = function(options, opt)
     {
         self = this;
         
		 if (!($(this).data("sfui") == "Video2"))
         {
            //alert("sfVideo2: Initializing");
            
			$(this).data("sfui", "Video2");
			var contents = "<div id='Video2Div'></div>";
			$(this).html(contents);
        }
        
        if (typeof options == "object")
        {
            if (typeof options.media != "undefined")
            {
                setMedia(options.media);
            }
            
            if (typeof options.jumpSeconds != "undefined")
            {
                JUMP_SECONDS = options.jumpSeconds;
            }
            
            if (typeof options.idVideo2_controller != "undefined")
            {
                objVideo2_controller = $("#"+ options.idVideo2_controller);
            }
            
            if (typeof options.lastMediaCallback != "undefined")
            {
                lastMediaCallback = options.lastMediaCallback;
            }
            
            if (typeof options.errorCallback != "undefined")
            {
                errorCallback = options.errorCallback;
            }
            
            if (typeof options.statsController != "undefined")
            {
                statsController = options.statsController;
            }
            
            if (typeof options.rightsController != "undefined")
            {
                rightsController = options.rightsController;
            }
            
            if (typeof options.movieSeenController != "undefined")
            {
                movieSeenController = options.movieSeenController;
            }
            
            load();
        }
        else if (typeof options == "string")
        {
            switch (options)
            {
				case "stop":
                    runStop();
                    break;
                    
                case "pause":
                    runPause();
                    break;
                    
                case "resume":
                    runPlay();
                    break;
                    
                case "play":
                    if ((typeof opt != "undefined") && (typeof opt.media != "undefined"))
                    {
                        setMedia(opt.media);
                    }
                    runPlay();
                    break;
                    
                case "backward":
                    runJumpBackward(JUMP_SECONDS);
                    break;
                    
                case "forward":
                    runJumpForward(JUMP_SECONDS);
                    break;
                    
                case "toogleMute":
                    toogleMute();
                    break;
                    
                case "RCKeyDefined":
                    objVideo2_controller.setVisible("visible");
                    boolMarkTime = true;
                    
                    switch (opt)
                    {
                        case $.sfKey.PLAY:
                            runPlay();
                            break;
                            
                         case $.sfKey.PAUSE:
                            if (boolBeginVideo)
                            {
                                runPause();
                            }
                            break;
                            
                         case $.sfKey.RW_:
                            if (boolBeginVideo)
                            {
                                if (TVPlugin.GetProductType() == $.sf.define.PL_TV_PRODUCT_TYPE_BD)
                                {
                                    runJumpBeginning();
                                }
                                else
                                {
                                    runJumpGeneric("backward");
                                }
                            }
                            break;
                            
                         case $.sfKey.RW:
                            if (boolBeginVideo)
                            {
                                runJumpGeneric("backward");
                            }
                            break;
                        
                        case $.sfKey.FF_:
                            if (boolBeginVideo)
                            {
                                if (TVPlugin.GetProductType() == $.sf.define.PL_TV_PRODUCT_TYPE_BD)
                                {
                                    runJumpEnd();
                                }
                                else
                                {
                                    runJumpGeneric("forward");
                                }
                            }
                            break;
                        
                        case $.sfKey.FF:
                            if (boolBeginVideo)
                            {
                                runJumpGeneric("forward");
                            }
                            break;
                            
                        case 1231: // BD rewind button pressed
                            if (boolBeginVideo)
                            {
                                scrollingButtonInterval = setInterval(function(){runJumpGeneric("backward");}, 300);
                            }
                            break;
                            
                        case 1230: // BD forward button pressed
                            if (boolBeginVideo)
                            {
                                scrollingButtonInterval = setInterval(function(){runJumpGeneric("forward");}, 300);
                            }
                            break;
                            
                        case 1232: // BD forward or rewind button released
                            clearInterval(scrollingButtonInterval);
                            break;
                            
                        case $.sfKey.STOP:
						case $.sfKey.RETURN:
                            runStop();
                            break;
						
						case $.sfKey.VOL_UP:
                            runVolumeUp();
							break;
                        
						case $.sfKey.VOL_DOWN:
                            runVolumeDown();
                            break;
                            
                        case $.sfKey.MUTE:
                            toogleMute();
                            break;
                            
                        case $.sfKey.INFO:
                            break;
                    }
                    break;
                    
                case "getTotalTime":
                    return PlayerPlugin.GetDuration();
                    
                case "getStatus":
                    return status;
                    
                case "show":
                    //alert("sfVideo2: Showing player");
                    $(this).show();
                    break;
                    
                case "hide":
                    //alert("sfVideo2: Hidding player");
                    $(this).hide();
                    break;
			}
        }
        
	    return this;
	};
    
    function updateVolumeButtons()
    {
        //alert("sfVideo2: updateVolumeButtons");
        
        if (volumeOSDSupported)
        {
            objVideo2_controller.setVolumeControlsVisible(true);
            
            objVideo2_controller.setVolume(AudioPlugin.GetVolume());
            
            var isMute = AudioPlugin.GetUserMute();
            
            if (isMute == $.sf.define.PLR_TRUE)
            {
                objVideo2_controller.setMute("mute");
            } 
            else if (isMute == $.sf.define.PLR_FALSE)
            {
                objVideo2_controller.setMute("unmute");
            }
            else
            {
                 alert("sfVideo2: updateVolumeButtons error");
            }
        }
        else
        {
            objVideo2_controller.setVolumeControlsVisible(false);
        }
    }
    
    /*
    * mute - $.sf.define.PLR_TRUE
    * unmute - $.sf.define.PLR_FALSE
    */
    function setMute(mute)
    {
        //alert("sfVideo2: setMute, mute="+mute);
        
        if (typeof mute == "undefined")
        {
            return false;
        }
        
        if (volumeSupported)
        {
            if (mute == $.sf.define.PLR_TRUE)
            {
                AudioPlugin.SetUserMute($.sf.define.PLR_TRUE);
            }
            else if (mute == $.sf.define.PLR_FALSE)
            {
                AudioPlugin.SetUserMute($.sf.define.PLR_FALSE);
            }
            else
            {
                 alert("sfVideo2: setMute error");
            }
        }
        
        updateVolumeButtons();
    }
    
    function toogleMute()
    {
        //alert("sfVideo2: toogleMute");
        
        var isMute = AudioPlugin.GetUserMute();
        
        if (isMute == $.sf.define.PLR_TRUE)
        {
            setMute($.sf.define.PLR_FALSE);
        } 
        else if (isMute == $.sf.define.PLR_FALSE)
        {
            setMute($.sf.define.PLR_TRUE);
        }
        else
        {
             alert("sfVideo2: toogleMute error");
        }
    }
    
     function runVolumeUp()
     {
        //alert("sfVideo2: Volume Up");

        if (volumeSupported)
        {
            AudioPlugin.SetVolumeWithKey($.sf.define.PL_AUDIO_VOLUME_KEY_UP);
        }

        updateVolumeButtons();
    }
    
    function runVolumeDown()
    {
        //alert("sfVideo2: Volume Down");

        if (volumeSupported)
        {
            AudioPlugin.SetVolumeWithKey($.sf.define.PL_AUDIO_VOLUME_KEY_DOWN);
        }

        updateVolumeButtons();
    }
    
    function setVolumeStrategy()
    {
        // check volume strategy
        var outputDevice = AudioPlugin.GetOutputDevice();

        if(outputDevice == $.sf.define.PL_AUDIO_OUTPUT_DEVICE_EXTERNAL || TVPlugin.GetProductType() == $.sf.define.PL_TV_PRODUCT_TYPE_BD)
        {
            // no volume support and no osd support
            volumeSupported = false;
            volumeOSDSupported = false;
        }
        else
        {
           if(outputDevice == $.sf.define.PL_AUDIO_OUTPUT_DEVICE_RECEIVER)
           {
                // volume support but no osd support
                volumeSupported = true;
                volumeOSDSupported = false;
           }
           else
           {
                // volume support and osd support
                volumeSupported = true;
                volumeOSDSupported = true;
           }
        }
    }
    
     function runStop()
     {
        //alert("sfVideo2: Stopping");
        
        PlayerPlugin.Stop();
        PlayerPlugin.ClearScreen();
        status = STOPPED;
        
        objVideo2_controller.changeButton("stop", isMediaMovie());
        
        this.totalTime = 0;
        this.currentTime = 0;
        
        boolBeginVideo = false;
        timeFullScreen = 0;
        boolMarkTime = true;
        currentMediaIndex = 0;
        
        PluginAPI.setOnScreenSaver();
    }
    
    function setMedia(data)
    {
        //alert("sfVideo2: Setting media");
        
        if (typeof data == "undefined")
        {
            media = new Array();
            return false;
        }
        
        if (data.length == 0)
        {
            media = new Array();
            return false;
        }
        
        media = data;
        currentMediaIndex = 0;
        
        return true;
    }
    
    function isMediaMovie()
    {
        return (media[currentMediaIndex].type == "movie");
    }
    
    function runPlay()
    {
        //alert("sfVideo2: Playing");
        
        var ret = false;
        
        if (status == PAUSED)
        {
            status = RESUME;
            ret = PlayerPlugin.Resume();
            objVideo2_controller.changeButton("play", isMediaMovie());
        }
        else if(status == STOPPED)
        {
            status = PLAYING;
            
            PluginAPI.setOffScreenSaver();
            
            setVolumeStrategy();
            updateVolumeButtons();
            
            var mediaNativeWidth = media[currentMediaIndex].width;
            var mediaNativeHeight = media[currentMediaIndex].height;
            
            var scaledHeight = Math.floor(MAX_WIDTH_SCREEN * mediaNativeHeight / mediaNativeWidth);
            var scaledWidth = 0;
            
            if (scaledHeight > MAX_HEIGHT_SCREEN)
            {
                scaledWidth = Math.floor(MAX_HEIGHT_SCREEN * mediaNativeWidth / mediaNativeHeight);
                scaledHeight = MAX_HEIGHT_SCREEN;
            }
            else
            {
                scaledWidth = MAX_WIDTH_SCREEN;
            }
            
            var scaledLeft = Math.floor((MAX_WIDTH_SCREEN - scaledWidth) / 2);
            var scaledTop = Math.floor((MAX_HEIGHT_SCREEN - scaledHeight) / 2);
            
            //alert(mediaNativeWidth);
            //alert(mediaNativeHeight);
            //alert(scaledWidth);
            //alert(scaledHeight);
            //alert(scaledLeft);
            //alert(scaledTop);
            
            /*
            $.each(media[currentMediaIndex], function(index, value)
            {
                alert(index+": "+value);
            });
            */
            
            //alert("sfVideo2: Trying to play "+media[currentMediaIndex].url)
            
            PlayerPlugin.SetDisplayArea(scaledLeft, scaledTop, scaledWidth, scaledHeight);
            ret = PlayerPlugin.Play(media[currentMediaIndex].url.mp4());
            
            objVideo2_controller.setBuffering(0);
            objVideo2_controller.setVisible("visible");
        }
        
        //alert("sfVideo2: Playing returns="+ret);
        
        return ret;
    }
    
    function runPause()
    {
        //alert("sfVideo2: Pausing");

        var ret = false;
        
        if (status == PLAYING || status == RESUME)
        {
            status = PAUSED;
            ret = PlayerPlugin.Pause();
            objVideo2_controller.changeButton("pause", isMediaMovie());
        }
        
        return ret;
    }
    
    function runJumpGeneric(type)
    {
        function getJumpSecondsMultiplier(jumpSecondsEvents)
        {
            if (jumpSecondsEvents < 12)
            {
                return 1;
            }
            else if (jumpSecondsEvents < 18)
            {
                return 3;
            }
            else if (jumpSecondsEvents < 24)
            {
                return 6;
            }
            else if (jumpSecondsEvents < 30)
            {
                return 12;
            }
            else 
            {
                return 30;
            }
        }
        
        if (!isMediaMovie())
        {
            return false;
        }
        
        clearTimeout(jumpSecondsTimer);
        
        if (!statusBeforeJump)
        {
            statusBeforeJump = status;
        }
        
        if (jumpType != type)
        {
            jumpOffset += jumpSecondsRun;
            jumpType = type;
            jumpSecondsEvents = 0;
            jumpSecondsRun = 0;
        }
        
        PlayerPlugin.Pause();
        status = PAUSED;
        objVideo2_controller.changeButton(type, isMediaMovie());
        
        if (type == "forward")
        {
            if (this.currentTime + jumpOffset + jumpSecondsRun < this.totalTime - 5000)
            {
                jumpSecondsRun = jumpSecondsRun + (getJumpSecondsMultiplier(jumpSecondsEvents) * JUMP_SECONDS * 1000);
                jumpSecondsEvents++;
                
                objVideo2_controller.setTime( formatTime(this.currentTime + jumpOffset + jumpSecondsRun) + "/" + formatTime(this.totalTime) );
                objVideo2_controller.setProgress((100 * (this.currentTime + jumpOffset + jumpSecondsRun)) / this.totalTime);
            }
            else
            {
                jumpSecondsRun = this.totalTime - this.currentTime - 15000;
                runJumpForward(parseInt(jumpSecondsRun / 1000));
                
                objVideo2_controller.setTime( formatTime(this.totalTime - 15000) + "/" + formatTime(this.totalTime) );
                objVideo2_controller.setProgress((100 * (this.totalTime - 15000)) / this.totalTime);
                
                jumpSecondsEvents = 0;
                jumpSecondsRun = 0;
                jumpType = null;
                jumpOffset = 0;
                
                if (statusBeforeJump != PAUSED)
                {
                    // block forward / rewind until video is buffered and playing
                    boolBeginVideo = false;
                    
                    runPlay();
                }
                
                statusBeforeJump = null;
                
                return true;
            }
        }
        else if (type == "backward")
        {
            if (this.currentTime + jumpOffset + jumpSecondsRun > 0)
            {
                jumpSecondsRun = jumpSecondsRun - (getJumpSecondsMultiplier(jumpSecondsEvents) * JUMP_SECONDS * 1000);
                jumpSecondsEvents++;
                
                objVideo2_controller.setTime( formatTime(this.currentTime + jumpOffset + jumpSecondsRun) + "/" + formatTime(this.totalTime) );
                objVideo2_controller.setProgress((100 * (this.currentTime + jumpOffset + jumpSecondsRun)) / this.totalTime);
            }
            else
            {
                jumpSecondsRun = this.currentTime;
                runJumpBackward(parseInt(jumpSecondsRun / 1000));
                
                objVideo2_controller.setTime( formatTime(0) + "/" + formatTime(this.totalTime) );
                objVideo2_controller.setProgress(0);
                
                jumpSecondsEvents = 0;
                jumpSecondsRun = 0;
                jumpType = null;
                jumpOffset = 0;
                
                if (statusBeforeJump != PAUSED)
                {
                    // block forward / rewind until video is buffered and playing
                    boolBeginVideo = false;
                    
                    runPlay();
                }
                
                statusBeforeJump = null;
                
                return true;
            }
        }
        
        jumpSecondsTimer = setTimeout(function()
        {
            if (jumpOffset + jumpSecondsRun > 0)
            {
                runJumpForward(parseInt((jumpOffset + jumpSecondsRun) / 1000));
            }
            else
            {
                runJumpBackward(parseInt(Math.abs(jumpOffset + jumpSecondsRun) / 1000));
            }
            
            jumpSecondsEvents = 0;
            jumpSecondsRun = 0;
            jumpType =  null;
            jumpOffset = 0;
            
            if (statusBeforeJump != PAUSED)
            {
                // block forward / rewind until video is buffered and playing
                boolBeginVideo = false;
                
                runPlay();
            }
            
            statusBeforeJump = null;
            
        }, 1000);
        
        return true;
     }
    
     function runJumpBackward(seconds)
     {
        //alert("sfVideo2: Rewind");
        
        if (isMediaMovie())
        {
            objVideo2_controller.changeButton("backward", isMediaMovie());
            PlayerPlugin.JumpBackward(seconds);
        }
     }
    
     function runJumpForward(seconds)
     {
        //alert("sfVideo2: Forward");
        
        if (isMediaMovie())
        {
            objVideo2_controller.changeButton("forward", isMediaMovie());
            PlayerPlugin.JumpForward(seconds);
        }
     }
    
     function runJumpBeginning()
     {
        //alert("sfVideo2: Beginning");
        
        if (isMediaMovie())
        {
            objVideo2_controller.changeButton("backward", isMediaMovie());
            PlayerPlugin.JumpBackward(parseInt(this.currentTime / 1000));
        }
     }
    
     function runJumpEnd()
     {
        //alert("sfVideo2: End");
        
        if (isMediaMovie() &&  (this.totalTime - this.currentTime > 15000))
        {
            objVideo2_controller.changeButton("forward", isMediaMovie());
            PlayerPlugin.JumpForward(parseInt((this.totalTime - this.currentTime - 15000) / 1000));
        }
     }
    
    function load()
    {
        //alert("sfVideo2: Loading");
        
        tagObject = "";
        tagObject += "<object id='pluginObjectPlayer' classid='clsid:SAMSUNG-INFOLINK-PLAYER' class='videoConfiguration'></object>"; // for player support
        tagObject += "<object id='pluginObjectAudio' classid='clsid:SAMSUNG-INFOLINK-AUDIO' ></object>"; // for audio support
        tagObject += "<object id='pluginObjectNNavi' classid='clsid:SAMSUNG-INFOLINK-NNAVI'></object>"; // for screen saver support
        tagObject += "<object id='pluginObjectTV' classid='clsid:SAMSUNG-INFOLINK-TV'></object>"; // for product type
        
        document.getElementById("Video2Div").innerHTML = tagObject ;
        
        PlayerPlugin = document.getElementById("pluginObjectPlayer");
        AudioPlugin = document.getElementById("pluginObjectAudio");
        TVMWPlugin = document.getElementById("pluginObjectTVMW"); // declared in index.html, needed also for blocking SOURCE KEY
        TVPlugin =  document.getElementById("pluginObjectTV");
        
        this.OriginalSource = TVMWPlugin.GetSource();
        TVMWPlugin.SetMediaSource();
        
        PlayerPlugin.SetTotalBufferSize(2*1024*1024);
        PlayerPlugin.SetInitialBuffer(1024*1024);
        PlayerPlugin.SetInitialTimeOut(15);
        
        PlayerPlugin.ClearScreen();
        
		$("#pluginObjectPlayer").width(MAX_WIDTH_SCREEN);
        $("#pluginObjectPlayer").height(MAX_HEIGHT_SCREEN);
		
        PlayerPlugin.SetDisplayArea(0, 0, MAX_WIDTH_SCREEN, MAX_HEIGHT_SCREEN);
        
        // attach events
        PlayerPlugin.OnCurrentPlayTime = "OnCurrentPlayTime";
        PlayerPlugin.OnBufferingComplete = "OnBufferingComplete";
        PlayerPlugin.OnBufferingProgress = "OnBufferingProgress";
        PlayerPlugin.OnBufferingStart = "OnBufferingStart";
        PlayerPlugin.OnConnectionFailed = "OnConnectionFailed";
        PlayerPlugin.OnNetworkDisconnected = "OnNetworkDisconnected";
        PlayerPlugin.OnRenderError = "OnRenderError";
        PlayerPlugin.OnRenderingComplete = "OnRenderingComplete";
        PlayerPlugin.OnStreamInfoReady = "OnStreamInfoReady";
        PlayerPlugin.OnStreamNotFound = "OnStreamNotFound";
        
        // for screen saver
        PluginAPI = new Common.API.Plugin();
        
        setVolumeStrategy();
        updateVolumeButtons();
    }
    
    function formatTime(seconds)
    {
        if(!isNaN(seconds) && seconds > 0)
        {
            seconds /= 1000;
            hours = Math.floor(seconds / 3600);
            seconds %= 3600;
            minutes = Math.floor(seconds / 60);
            seconds %= 60;
            seconds = parseInt(seconds);
            (hours < 10) ? hps = "0" : hps = "";
            (minutes < 10) ? mps = "0" : mps = "";
            (seconds < 10) ? sps = "0" : sps = "";

            return hps+hours+":"+mps+minutes+":"+sps+seconds;
        }
        else
        {
            return "00:00:00";
        }
    }
    
    OnCurrentPlayTime = function(time)
    {
        //alert("sfVideo2: OnCurrentPlayTime, time="+time);
        
        this.currentTime = parseInt(time);
        
        if (status == PLAYING ||  status == PAUSED || status == RESUME )
        {
            if ( status != PAUSED )
            {
                status = PLAYING;
                objVideo2_controller.changeButton("play", isMediaMovie());
            }
            else if ( status == PAUSED )
            {
                objVideo2_controller.changeButton("pause", isMediaMovie());
            }
            
            objVideo2_controller.setProgress((100 * this.currentTime) / this.totalTime);
            
            //if (volumeOSDSupported)
            //{
            //    objVideo2_controller.setVolume(AudioPlugin.GetVolume());
            //}
            
            boolBeginVideo = true;
        }
        else if (status == STOPPED)
        {
            boolBeginVideo = false;
            objVideo2_controller.changeButton("stop", isMediaMovie());
        }
        
        if (this.currentTime <= this.totalTime)
        {
            objVideo2_controller.setTime( formatTime(this.currentTime) + "/" + formatTime(this.totalTime) );
        }
        else
        {
            objVideo2_controller.setTime( formatTime(this.totalTime) + "/" + formatTime(this.totalTime) );
        }
        
        if (boolMarkTime)
        {
            timeFullScreen = this.currentTime;
            boolMarkTime = false;
        } 
        
        if (boolMarkTime == false)
        {
            if ( this.currentTime >= (timeSecondHidden + timeFullScreen) )
            {
                objVideo2_controller.setVisible("hidden");
            }
        }
    }
    
    OnStreamInfoReady = function()
    {
        //alert("sfVideo2: OnStreamInfoReady");
        
        this.totalTime = parseInt(PlayerPlugin.GetDuration());
        objVideo2_controller.setTime( formatTime(0) + "/" + formatTime(this.totalTime) );
        
        var currentVideo = media[currentMediaIndex];
        var lastVideo = media[media.length-1];
            
        if (typeof statsController != "undefined")
        {
            if (currentVideo.type == "advert" && currentVideo.id != null && lastVideo.type == "movie" && lastVideo.id != null)
            {
                statsController.advertsStats.sendHit("AID", currentVideo.id, "ATITLE", currentVideo.title, "MID", lastVideo.id, "MTITLE", lastVideo.title);
                statsController.trackingCode.sendHit(currentVideo.tracking_code_tv);
            }
            else if (currentVideo.type == "movie" && currentVideo.id != null)
            {
                statsController.moviesStats.sendHit("MID", currentVideo.id, "MTITLE", currentVideo.title);
            }
        }
        
        if (typeof rightsController != "undefined")
        {
            if (currentVideo.type == "advert" && currentVideo.id != null)
            {
                rightsController.sendHit(currentVideo.id, "video_start");
            }
        }
        
        if (typeof movieSeenController != "undefined")
        {
            if (currentVideo.type == "movie" && currentVideo.id != null)
            {
                movieSeenController.sendHit(currentVideo.id);
            }
        }
    };
    
    OnBufferingStart = function()
    {
        //alert("sfVideo2: OnBufferingStart");
        
        boolMarkTime = true;
        objVideo2_controller.setBuffering(0);
    };
    
    OnBufferingProgress = function(percent)
    {
        //alert("sfVideo2: OnBufferingProgress, percent=" + percent);
        
        objVideo2_controller.setBuffering(percent);
    };
    
    OnBufferingComplete = function()
    {
        //alert("sfVideo2: OnBufferingComplete");
        
        boolMarkTime = true;
        objVideo2_controller.setBuffering(100);
    };
    
    OnRenderingComplete = function()
    {
        //alert("sfVideo2: OnRenderingComplete");
        
        PlayerPlugin.Stop();
        status = STOPPED;
        objVideo2_controller.changeButton("stop", isMediaMovie());
        
        this.currentTime = 0;
        this.totalTime = 0;
        
        if (typeof rightsController != "undefined")
        {
            var currentVideo = media[currentMediaIndex];
            
            if (currentVideo.type == "advert" && currentVideo.id != null)
            {
                rightsController.sendHit(currentVideo.id, "video_end");
            }
        }
        
        if (currentMediaIndex < media.length - 1)
        {
            //alert("sfVideo2: Next media available");
            currentMediaIndex++;
            runPlay();
        }
        else
        {
            //alert("sfVideo2: Last media");
            runStop();
            if (typeof lastMediaCallback != "undefined")
            {
                lastMediaCallback();
            }
        }
    };
    
    OnConnectionFailed = function()
    {
        //alert("sfVideo2: OnConnectionFailed");
        
        runStop();
        
        if (typeof errorCallback != "undefined")
        {
            errorCallback(1, "Nie udało się nawiązać połączenia z serwerem."); // Failed to connect to streaming server.
        }
    };
    
    OnNetworkDisconnected = function()
    {
        //alert("sfVideo2: OnNetworkDisconnected");
        
        runStop();
        
        if (typeof errorCallback != "undefined")
        {
            errorCallback(2, "Brak połączenia z siecią."); // Usually this event means network is disconnected during the streaming.
        }
    };
    
    OnStreamNotFound = function()
    {
        //alert("sfVideo2: OnStreamNotFound");
        
        runStop();
        
        if (typeof errorCallback != "undefined")
        {
            errorCallback(3, "Nie znaleziono materiału wideo."); // Streaming server replys that the stream specified by url parameter of Play() API does not exist.
        }
    };
    
    OnRenderError = function(renderErrorType)
    {
        //alert("sfVideo2: OnRenderError, renderErrorType="+renderErrorType);
        
        runStop();
        
        if (typeof errorCallback != "undefined")
        {
            switch (renderErrorType)
            {
                case 1:
                    errorCallback(4, "Niewspierany kontener."); // 1 : Unsupported container
                    break;
                    
                case 2:
                    errorCallback(5, "Niewspierany kodek wideo."); // 2 : Unsupported video codec
                    break;
                    
                case 3:
                    errorCallback(6, "Niewspierany kodek audio."); // 3 : Unsupported audio codec
                    break;
                    
                case 4:
                    errorCallback(7, "Niewspierana rozdzielczość wideo."); // 4 : Unsupported video resolution
                    break;
                
                default:
                    errorCallback(8, "Nieznany błąd"); // Unknown error
                    break;
            }   
        }
    };
    
})(jQuery);